/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ch.il06.dbhelper.connectionpooling;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.HashMap;


/**
 *
 * @author ncaspar
 */
public class DbPoolPairManager {
    private static DbPoolPairManager instance = null;

    private HashMap<String, DbConnectionPoolPair> pools = new HashMap<String, DbConnectionPoolPair>();

    private final String STANDARD_NAME = "standard";
    
    private DbPoolPairManager() {
        
    }
    
    public static DbPoolPairManager getInstance() {
        if(instance == null) {
            instance = new DbPoolPairManager();
        }
        return instance;
    }

    /**
     * Fügt einen Pool zum Manager hinzu.
     * @param name
     * @param pool
     */
    public void addPool(String name, DbConnectionPoolPair pool) {
        pools.put(name, pool);
    }
    
    public void addPool(DbConnectionPoolPair pool) {
        addPool(STANDARD_NAME, pool);
    }

    /**
     * Gibt eine freie Connection des Pools pool zurück.
     * @param pool
     * @return Connection oder null, wenn der Pool nicht existiert oder keine Verbindungen mehr frei sind.
     */
    public Connection getConnection(String pool) {
        if(pools.containsKey(pool)) {
            try {
                return pools.get(pool).getConnection();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
        }
        return null;
    }
    
    public Connection getConnection(){
        return getConnection(STANDARD_NAME);
    }

    /**
     * Gibt eine besetzte Verbindung wieder frei.
     * @param pool
     * @param connection
     */
    public void putConnection(String pool, Connection connection) {
        if(pools.containsKey(pool)) {
            try {
                pools.get(pool).putConnection(connection);
            } catch (SQLException ex) {}
        }
    }
    
	public void putConnection(Connection connection) {
		putConnection(STANDARD_NAME, connection);
	}
    
    @Override
    public String toString() {
        String result = "DbConnectionManager\n" +
                        "=========================\n";
        Object[] values = pools.values().toArray();
        Object[] keys = pools.keySet().toArray();
        for(int i = 0; i < values.length; ++i) {
            result += "\nPool " + keys[i] + "\n";
            result += values[i].toString();
            result += "\n";
        }
        return result;
    }
}
