package ch.il06.zeiterfassung.db;

import java.util.Date;
import java.util.GregorianCalendar;

public abstract class Calendar {
	private DbInterface db;

	public Calendar(DbInterface db) {
		this.db = db;
	}

	/**
	 * Gibt alle eingetragenen Tage zurück, die zwischen "from" und "to" liegen.
	 * Wenn keine Tage dazwischen liegen, wird null zurückgegeben.
	 * 
	 * @return Day[]|null
	 */
	@SuppressWarnings("deprecation")
	public Day[] getDays(Date from, Date to) {
		return db.getDays(from, to, this);
	}

	/**
	 * Einen Tag in den Kalender eintragen.
	 */
	public void insertDay(Day day) {
		db.save(day, this);
	}
	
	public int getMonthDay(String month, String year){
		GregorianCalendar c = new GregorianCalendar();
		int m = Integer.parseInt(month);
		int y = Integer.parseInt(year);
		c.set(GregorianCalendar.YEAR, y);
		c.set(GregorianCalendar.MONTH, m - 1);
		return c.getActualMaximum(GregorianCalendar.DAY_OF_MONTH);
	}
	
	/**
	 * Nicht vergessen Month -1 zu rechnen denn dieser Kalender kennt nur 0-11 Monate.
	 * @param month
	 * @param year
	 * @return
	 */
	public int getMonthDay(int month, int year){
		GregorianCalendar c = new GregorianCalendar();
		c.set(GregorianCalendar.YEAR, year);
		c.set(GregorianCalendar.MONTH, month);
		return c.getActualMaximum(GregorianCalendar.DAY_OF_MONTH);
	}

}
