package ch.il06.zeiterfassung.db;

import java.sql.Connection;
import java.sql.ResultSet;

/**
*
* @author mstutz
*/

public abstract class DbCallable {
	public abstract Object dbCall(Connection c) throws Exception;
	
	public Type getType(String ts) {
		if (ts.equals("Krankheit")) {
			return Type.Krankheit;
		} else if (ts.equals("Ferien")) {
			return Type.Ferien;
		} else if (ts.equals("Sonstige Abwesenheiten")) {
			return Type.SonstigeAbwesenheit;
		} else if (ts.equals("Feiertag")) {
			return Type.Feiertag;
		} else if (ts.equals("Ausbildung")) {
			return Type.Ausbildung;
		} else if (ts.equals("Schule")) {
			return Type.Schule;
		}
		return null;
	}	
	
	public User getUserByResultSet(ResultSet rs, Connection c) throws Exception {
		User user = new User(rs);
		// System.out.println("getUserByResultSet: " + user.getUid());
		int berufsbildner = rs.getInt("Berufsbildner");
		if (berufsbildner != 0) {
			user.setBerufsbildner((User)new DbMethods().new GetUserById(berufsbildner).dbCall(c));
		}
		int lehrmeister = rs.getInt("Lehrmeister");
		if (lehrmeister != 0) {
			user.setLehrmeister((User)new DbMethods().new GetUserById(lehrmeister).dbCall(c));
		}
		Group g =  (Group) new DbMethods().new GetGroupByUserId(rs.getInt("UID")).dbCall(c);
		user.setGroup(g);

		Role r = (Role) new DbMethods().new GetRoleById(rs.getInt("Rolle")).dbCall(c);
		user.setRole(r);

		return user;
	}
}
