package ch.il06.zeiterfassung.db;

import java.sql.ResultSet;
import java.sql.SQLException;

public class Group {

	private int gid;
	private String name;
	private User lehrmeister;

	public Group() {

	}

	public Group(ResultSet rs) throws SQLException {
		gid = rs.getInt("GID");
		name = rs.getString("Gruppenname");
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public User getLehrmeister() {
		return lehrmeister;
	}

	public void setLehrmeister(User lehrmeister) {
		this.lehrmeister = lehrmeister;
	}

	public int getGid() {
		return gid;
	}

	public void setGid(int gid) {
		this.gid = gid;
	}

	public void save() throws Exception {
		int id = Db.getInstance().save(this);
		gid = id;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof Group) {
			Group g2 = (Group) obj;
			return g2.getGid() == getGid();
		}
		throw new ClassCastException("Objekt ist keine Group");
	}

	@Override
	public String toString() {
		String nameString = name;
		String lehrmeisterString;
		if (null == lehrmeister) {
			lehrmeisterString = "";
		} else {
			lehrmeisterString = lehrmeister.toString();
		}
		return nameString + " " + lehrmeisterString;
	}
}
