package ch.il06.zeiterfassung.db;

import java.sql.ResultSet;
import java.sql.SQLException;

public class User {

	private int uid = 0;
	private String name;
	private String vorname;
	private float anzahlFerientage;
	private String pid;
	private String departement;
	private User berufsbildner;
	private User lehrmeister;
	private String passwort;
	private boolean passwortPlain = true;
	private Role role = Role.Apprentice;
	private Group group;

	public User() {

	}

	public User(ResultSet rs) throws SQLException {
		this.uid = rs.getInt("UID");
		this.name = rs.getString("Nachname");
		this.vorname = rs.getString("Vorname");
		this.anzahlFerientage = rs.getFloat("Anzahl_Ferientage");
		this.pid = rs.getString("PID");
		this.departement = rs.getString("Departement");
		this.passwort = rs.getString("Passwort");
		this.setPasswortPlain(false);
	}

	public int getUid() {
		return uid;
	}

	public void setUid(int uid) {
		this.uid = uid;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getVorname() {
		return vorname;
	}

	public void setVorname(String vorname) {
		this.vorname = vorname;
	}

	public float getAnzahlFerientage() {
		return anzahlFerientage;
	}

	public void setAnzahlFerientage(float anzahlFerientage) {
		this.anzahlFerientage = anzahlFerientage;
	}

	public String getPid() {
		return pid;
	}

	public void setPid(String pid) {
		this.pid = pid;
	}

	public String getDepartement() {
		return departement;
	}

	public void setDepartement(String departement) {
		this.departement = departement;
	}

	public User getBerufsbildner() {
		return berufsbildner;
	}

	public void setBerufsbildner(User berufsbildner) {
		this.berufsbildner = berufsbildner;
	}

	public User getLehrmeister() {
		return lehrmeister;
	}

	public void setLehrmeister(User lehrmeister) {
		this.lehrmeister = lehrmeister;
	}

	public Role getRole() {
		return role;
	}
	
	public void setRole(Role rl) {
		role = rl;
	}

	public void save() throws Exception {
		int id = Db.getInstance().save(this);
		uid = id;
	}

	public Group getGroup() {
		return group;
	}

	public void setGroup(Group group) {
		this.group = group;
	}

	public void setPasswort(String passwort) {
		this.passwort = passwort;
	}

	public String getPasswort() {
		return passwort;
	}
	
	public void setPasswortPlain(boolean passwortPlain) {
		this.passwortPlain = passwortPlain;
	}

	public boolean isPasswortPlain() {
		return passwortPlain;
	}

	/**
	 * Creates a User String with Prename, Familiyname and Pid Example: Fabian
	 * Hediger (A955233)
	 * 
	 * @param user
	 * @return UserString
	 */
	@Override
	public String toString() {
		return getVorname() + " " + getName() + " (" + getPid()
		+ ")";
	}
}
