package ch.il06.zeiterfassung.db;

import ch.il06.zeiterfassung.web.Helper;

public class UserCalendar extends Calendar {

	private User user;

	public UserCalendar(DbInterface db, User user) {
		super(db);
		this.user = user;
	}

	public User getUser() {
		return user;
	}
	
	public String toString() {
		String userString = user.toString();
		
		return userString;
	}
	/**
	 * TODO JAVA DOC
	 * @param day
	 * @param month
	 * @param year
	 * @param i
	 * @return
	 */
	public String prepareDate(String day, String month, String year, int i){
		if(i < 10) {
			day= "0" + i;
		}else{
			day = "" + i;
		}
		return day = day + "." + month + "." + year;
		
	}
	/**
	 * JAVA DOC TODO
	 * @param wd
	 * @param day
	 * @param morningOrAfternoon
	 * @param m
	 * @return
	 */
	public String checkArrayWorkdayFrom(WorkDay[] wd, String day, int morningOrAfternoon) {
		return checkArrayWorkday(wd, day, morningOrAfternoon, true);
	}
	
	/**
	 * JAVA DOC TODO
	 * @param wd
	 * @param day
	 * @param morningOrAfternoon
	 * @return
	 */
	public String checkArrayWorkdayTo(WorkDay[] wd, String day, int morningOrAfternoon) {
		return checkArrayWorkday(wd, day, morningOrAfternoon, false);
	}
	
	/**
	 * JAVA DOC TODO
	 * @param wd WorkDay Array
	 * @param day
	 * @param morningOrAfternoon 0 for Morning and 1 for Afternoon
	 * @param from If true it is from, if it is false it is to
	 * @return
	 */
	private String checkArrayWorkday(WorkDay[] wd, String day, int morningOrAfternoon, boolean from) {
		if(null == wd ){
			return "--:--";
		}
	
		for (WorkDay w : wd) {
			String wDay = Helper.convertTimeStampToTimeString(w.getDate().getTime(), "dd.MM.yyyy");
			if (day.equals(wDay) ) {
				
				if (from) {
					long wLTime = w.getWorktimes()[morningOrAfternoon].getFrom();
					String wSTime = Helper.convertTimeStampToTimeString(wLTime *1000, "HH:mm");
					return wSTime;
				}
				long wLTime = w.getWorktimes()[morningOrAfternoon].getTo();
				String wSTime = Helper.convertTimeStampToTimeString(wLTime * 1000, "HH:mm");
				return wSTime;
			}
		}	
		return "--:--";
	}
	/**
	 * TODO JAVA DOC
	 * @param wdOfficialHoliday
	 * @param day
	 * @return
	 */
	public String checkArrayMustWorkTime(DayRange[] wdOfficialHoliday, String day) {
	
		if(null == wdOfficialHoliday){
			return "08:24";
		}
		for (DayRange wdo : wdOfficialHoliday) {
			String wDay = Helper.convertTimeStampToTimeString(wdo.getAnzahlStunden(), "dd.MM.yyyy");
			if (day.equals(wDay) ) {
				String wSTime = Helper.convertTimeStampToTimeString(wdo.getAnzahlStunden(), "HH:mm");
				return wSTime;
			}
		}	
		return "08:24";
	}

}
