package ch.il06.zeiterfassung.web.controller;

import java.io.IOException;

import javax.servlet.ServletException;

import ch.il06.zeiterfassung.db.Db;
import ch.il06.zeiterfassung.db.Group;
import ch.il06.zeiterfassung.db.Role;
import ch.il06.zeiterfassung.db.User;
import ch.il06.zeiterfassung.web.AbstractController;

/**
 * Erledigt alle Sachen die Relevant für die/den LehrmeisterIn sind.
 * 
 * @author bekim, benjamin
 * 
 */
public class BenutzerController extends AbstractController {

	/**
	 * Prüft ob der User eingeloggt.
	 * 
	 * @param action
	 * @author mstutz
	 * @return true wenn der User eingeloggt ist und false, wenn nicht.
	 */
	@Override
	public boolean isAllowed(String action) {
		return request.getSession().getAttribute("currentUser") != null
		&& !((User)request.getSession().getAttribute("currentUser")).getRole().equals(Role.Apprentice);
		// return true;
	}

	public void user_suchenAction() throws ServletException, IOException,
			Exception {

		Db db = (Db) Db.getInstance();
		String disabled = "disabled='disabled'";
		Boolean showTable = false;
		setGroupsInRequest(db);
		if (null != request.getParameter("suchen")) {
			setDatasInRequest(db);
			disabled = "";
			showTable = true;
		}
		
		request.setAttribute("disabled", disabled);
		request.setAttribute("show", showTable);
		requestDespatcher("/benutzer/user_suchen.jsp");

	}

	private void setDatasInRequest(Db db) throws Exception, ServletException {

		String pid = request.getParameter("pid");
		String name = request.getParameter("name");
		String vorname = request.getParameter("vorname");
		String gruppe = request.getParameter("gruppe");

		User[] user;
		if (!"".equals(gruppe)) {
			
			Group[] groups = db.searchGroup(gruppe, null);
			if (groups.length >= 1) {
				
				user = db.searchUser(pid, name, vorname, groups[0]);
				request.setAttribute("users", user);
			}
		} else {
			
			user = db.searchUser(pid, name, vorname, null);
			request.setAttribute("users", user);
		}

	}

	private void setGroupsInRequest(Db db) throws Exception, ServletException,
			IOException {

		Group[] groups = db.searchGroup(null, null);
		request.setAttribute("groups", groups);

	}

}
