package ch.il06.zeiterfassung.web.controller;

import java.io.IOException;
import java.util.Date;

import javax.servlet.ServletException;

import ch.il06.zeiterfassung.db.Db;
import ch.il06.zeiterfassung.db.Role;
import ch.il06.zeiterfassung.db.User;
import ch.il06.zeiterfassung.db.UserCalendar;
import ch.il06.zeiterfassung.db.WorkDay;
import ch.il06.zeiterfassung.web.AbstractController;


/**
 * 
 * @author Fabian Hediger (A955233)
 * 
 */
public class BerufsbildnerController extends AbstractController {
	
	
	public WorkDay[] getWorkDays(Date from, Date to, UserCalendar uc) throws Exception {
		return Db.getInstance().getWorkDays(from, to, uc);
	}

	/**
	 * Prüft ob der User eingeloggt.
	 * 
	 * @param action
	 * @author mstutz
	 * @return true wenn der User eingeloggt ist und false, wenn nicht.
	 */
	@Override
	public boolean isAllowed(String action) {
		return request.getSession().getAttribute("currentUser") != null
		&& ((User)request.getSession().getAttribute("currentUser")).getRole().equals(Role.Instructor);
	}

	/**
	 * Zeigt die Willkommensmeldung an.
	 * 
	 * @throws javax.servlet.ServletException
	 * @throws java.io.IOException
	 */
	public void indexAction() throws ServletException, IOException {
		requestDespatcher("/berufsbildner/index.jsp");
	}

}
