/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ch.il06.zeiterfassung.web.controller;

import ch.il06.zeiterfassung.db.Db;
import ch.il06.zeiterfassung.db.DbInterface;
import ch.il06.zeiterfassung.db.Role;
import ch.il06.zeiterfassung.db.User;
import ch.il06.zeiterfassung.web.AbstractController;


import java.io.IOException;
import javax.servlet.ServletException;

/**
 *
 * @author ncaspar, bkadrija
 */
public class IndexController extends AbstractController {

    /**
     * Zeigt die Login-Maske an.
     * @author mstutz
     * @throws java.io.IOException
     * @throws javax.servlet.ServletException
     */
    public void indexAction() throws IOException, ServletException {
    	//this.response.getOutputStream().println("IndexController::indexAction()");
    	requestDespatcher("/index/index.jsp");
    }
    
    public void loginAction() throws Exception {
        String pid = request.getParameter("pid");
        String password = request.getParameter("password");
        
        requestPidAndPassword(pid, password);
        DbInterface db = Db.getInstance();
		User user = db.login(pid, password);
		if(user==null)
			 request.setAttribute("fehlerMessage","Benutzer oder Passwort stimmt NICHT!");
		requestUser(user);
		redirectUser(user);
    }

	private void requestUser(User user) throws ServletException, IOException {
		if (user == null) {
		    //Message.getInstance().addMessage("Die eingegeben Daten waren nicht korrekt.");
			requestDespatcher("/index/index.jsp");
		    return;
		}	
	}

	private void requestPidAndPassword(String pid, String password) throws ServletException, IOException {
        if(isEmpty(pid) || isEmpty(password)) {
        	 request.setAttribute("fehlerMessage","Benutzer oder Passwort stimmt NICHT!");
        	requestDespatcher("/index/index.jsp");
            return;
        }
	}

	private void redirectUser(User user) throws IOException {
		request.getSession().setAttribute("currentUser", user);
		
		requestApprentice(user);
		requestInstructor(user);
		requestMaster(user);
	}
    
    private void requestMaster(User user) throws IOException {
		if(user.getRole().equals(Role.Master)){
			response.sendRedirect(basePath + "lehrmeister/index");
		}
	}

	private void requestInstructor(User user) throws IOException {
		if(user.getRole().equals(Role.Instructor)){
			response.sendRedirect(basePath + "berufsbildner/index");
	 	}
	}

	private void requestApprentice(User user) throws IOException {
		if(user.getRole().equals(Role.Apprentice)){
			response.sendRedirect(basePath + "lehrling/index");
		}
	}

	/**
     * Löscht die Session und leitet auf die Login-Maske weiter.
     * @throws java.io.IOException
     */
    public void logoutAction() throws IOException {
        request.getSession().invalidate();
        response.sendRedirect(basePath + "index/index");
    }
}
