package ch.il06.zeiterfassung.db;

import java.util.Date;

public abstract class Calendar {
	private DbInterface db;

	public Calendar(DbInterface db) {
		this.db = db;
	}

	/**
	 * Gibt alle eingetragenen Tage zurück, die zwischen "from" und "to" liegen.
	 * Wenn keine Tage dazwischen liegen, wird null zurückgegeben.
	 * 
	 * @return Day[]|null
	 */
	@SuppressWarnings("deprecation")
	public Day[] getDays(Date from, Date to) {
		return db.getDays(from, to, this);
	}

	/**
	 * Einen Tag in den Kalender eintragen.
	 */
	public void insertDay(Day day) {
		db.save(day, this);
	}

}
