package ch.il06.zeiterfassung.db;

import java.sql.ResultSet;
import java.sql.SQLException;

public class User {

	private int uid;
	private String name;
	private String vorname;
	private float anzahlFerientage;
	private String pid;
	private String departement;
	private User berufsbildner;
	private User lehrmeister;
	private Role role = Role.Apprentice;
	private Group group;

	public User() {

	}

	public User(ResultSet rs) throws SQLException {
		this.uid = rs.getInt("UID");
		this.name = rs.getString("Nachname");
		this.vorname = rs.getString("Vorname");
		this.anzahlFerientage = rs.getFloat("Anzahl_Ferientage");
		this.pid = rs.getString("PID");
		this.departement = rs.getString("Departement");
	}

	public int getUid() {
		return uid;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getVorname() {
		return vorname;
	}

	public void setVorname(String vorname) {
		this.vorname = vorname;
	}

	public float getAnzahlFerientage() {
		return anzahlFerientage;
	}

	public void setAnzahlFerientage(float anzahlFerientage) {
		this.anzahlFerientage = anzahlFerientage;
	}

	public String getPid() {
		return pid;
	}

	public void setPid(String pid) {
		this.pid = pid;
	}

	public String getDepartement() {
		return departement;
	}

	public void setDepartement(String departement) {
		this.departement = departement;
	}

	public User getBerufsbildner() {
		return berufsbildner;
	}

	public void setBerufsbildner(User berufsbildner) {
		this.berufsbildner = berufsbildner;
	}

	public User getLehrmeister() {
		return lehrmeister;
	}

	public void setLehrmeister(User lehrmeister) {
		this.lehrmeister = lehrmeister;
	}

	public Role getRole() {
		return role;
	}
	
	public void setRole(Role rl) {
		role = rl;
	}

	public void save() {
		int id = Db.getInstance().save(this);
		uid = id;
	}

	public Group getGroup() {
		return group;
	}

	public void setGroup(Group group) {
		this.group = group;
	}
	
//	private int uid;
//	private String name;
//	private String vorname;
//	private float anzahlFerientage;
//	private String pid;
//	private String departement;
//	private User berufsbildner;
//	private User lehrmeister;
//	private Role role = Role.Apprentice;
//	private Group group;
	
	
	@Override
	public String toString() {
		String uidString = uid + "";
		String nameString = name;
		String vornameString = vorname;
		String anzahlFerientageString = anzahlFerientage + "";
		String pidString = pid;
		String departementString = departement;
		String berufsbildnerString = berufsbildner.toString();
		String lehrmeisterString = lehrmeister.toString();
		String groupString = group.toString();
		
		return uidString + " " + 
			   nameString + " " + 
			   vornameString + " " + 
			   anzahlFerientageString + " " + 
			   pidString + " " +
			   departementString + " " + 
			   berufsbildnerString + " " +
			   lehrmeisterString + " " +
			   groupString + " ";
	}
}
