package ch.il06.zeiterfassung.db.test;

import static org.junit.Assert.*;

import java.util.GregorianCalendar;

import org.junit.Test;

import ch.il06.zeiterfassung.db.*;

public class DbInterfaceTest {

	@Test
	public void testLogin() {
		DbInterface db = Db.getInstance();

		// User und Passwort falsch
		assertNull(db.login("gibtesnicht", "asdasdasd"));

		// Passwort falsch
		assertNull(db.login("A955269", "asdasdasd"));

		// Beides richtig
		assertNotNull(db.login("A955269", "12345"));

		// Falscher Username... Passwort von einem existierenden User
		assertNull(db.login("asdasdasdasd", "12345"));
	}

	@Test
	public void testCreateUserApprentice() {
		fail("Not yet implemented");
	}

	@Test
	public void testCreateUserInstructor() {
		fail("Not yet implemented");
	}

	@Test
	public void testSearchUser() {
		DbInterface db = Db.getInstance();
		User[] users = db.searchUser("a955330", null, null, null);
		assertTrue(1 == users.length);
		assertTrue(("Sebregondi".equals(users[0].getName())));
		fail("Not yet implemented");
	}

	@Test
	public void testSearchGroup() {
		DbInterface db = Db.getInstance();
		String group = "Il06";
		
		db.searchGroup(group);
		
		assertNotNull(group);
	}

	@Test
	public void testCreateGroup() {
		DbInterface db = Db.getInstance();
		String name = "Il06";
		User master = new User();

		Group il06 = db.createGroup(name, master);
		
		assertNotNull(il06);
		assertFalse(name == "il07");
	}

	@Test
	public void testGetCalendarByApprentice() {
		DbInterface db = Db.getInstance();
		User[] users = db.searchUser("a955330", null, null, null);
		Calendar kalender = db.getCalendarByApprentice(users[0]);
		java.util.Calendar from = GregorianCalendar.getInstance();
		java.util.Calendar to = GregorianCalendar.getInstance();
		from.set(2008, 8, 1);
		to.set(2008, 8, 2);
		Day[] days = kalender.getDays(from.getTime(), to.getTime());
		//TODO: hier weiter machen!
		//assertTrue(1 == days[0]);
		fail("Not yet implemented");
	}

	@Test
	public void testGetCalendarByGroup() {
		fail("Not yet implemented");
	}

	@Test
	public void testGetOfficialHolidayCalendar() {
		fail("Not yet implemented");
	}

	@Test
	public void testGetDays() {
		DbInterface db1 = Db.getInstance();
		Calendar cal = db1.getOfficialHolidayCalendar(); 
		java.util.Calendar from = GregorianCalendar.getInstance();
		java.util.Calendar to = GregorianCalendar.getInstance();
		from.set(2008, 8, 1);
		to.set(2008, 8, 2);	
		Day[] days  = cal.getDays(from.getTime() ,to.getTime() );
		assertTrue(1 == days.length);
		
	}

	@Test
	public void testInsertDay() {
		DbInterface db1 = Db.getInstance();
		Calendar cal = db1.getOfficialHolidayCalendar();
//		Day day = new Day(); //TODO tag monat jahr
//		db1.insertDay(day, cal); 
		// TODO check if day is inserted
		
		
		
	}

	@Test
	public void testGetInstance() {
		DbInterface db1 = Db.getInstance();
		DbInterface db2 = Db.getInstance();
		assertTrue(db1 == db2);
	}

}
