package ch.il06.zeiterfassung.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

import ch.il06.zeiterfassung.db.User;

public class Calendar extends JPanel implements ActionListener{

int month; //1:12 
int year;
JButton nextMonth;
JButton lastMonth;
JPanel nextMonthPanel;
JPanel lastMonthPanel;
JPanel showMonthPanel;
CalendarTable ct;
JLabel showMonth;
User user;
MainFrame mf;
	
/**
 *
 * @param month, 1:12
 */
	public Calendar(int month, int year, User user, MainFrame mf) {
		this.mf = mf;
		this.user = user;
		this.month = month;
		this.year = year;
		this.setLayout(new BorderLayout());
		this.createComponents();
		this.formateComponents();
		this.showActualMonth();
		this.addComponents();
	}
	
	private void formateComponents() {
		this.showMonthPanel.setBackground(Color.GRAY);
		this.showMonth.setForeground(Color.WHITE);
	}

	private void createComponents() {
		ct = new CalendarTable(month, year, user, mf);
		nextMonth = new JButton("-->");
		nextMonth.addActionListener(this);
		lastMonth = new JButton("<--");
		lastMonth.addActionListener(this);
		nextMonthPanel = new JPanel();
		//TODO: Pfeile zentrieren
		lastMonthPanel = new JPanel();
		showMonth = new JLabel();
		showMonthPanel = new JPanel();
	}

	private void showActualMonth() {
		int calendarMonat = ct.gc.get(java.util.Calendar.MONTH) + 1;
		int calendarJahr = ct.gc.get(java.util.Calendar.YEAR);
		if (calendarMonat < 10) {
			showMonth.setText("0" + Integer.toString(calendarMonat) + "." + Integer.toString(calendarJahr));
		} else {			
			showMonth.setText(Integer.toString(calendarMonat) + "." + Integer.toString(calendarJahr));
		}
		showMonth.setHorizontalAlignment(SwingConstants.CENTER);
	}

	private void addComponents() {
		nextMonthPanel.add(nextMonth);
		lastMonthPanel.add(lastMonth);
		showMonthPanel.add(showMonth);
		this.add(ct, BorderLayout.CENTER);
		this.add(nextMonthPanel, BorderLayout.EAST);
		this.add(lastMonthPanel, BorderLayout.WEST);
		this.add(showMonthPanel, BorderLayout.NORTH);
	}
	

	
	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == nextMonth) {
			this.month++;
			this.changeTable();
		}
		else if (e.getSource() == lastMonth) {
			this.month--;
			this.changeTable();
		}
	}

	
	private void changeTable() {
		this.remove(ct);
		ct = new CalendarTable(month, year, user, mf);
		this.add(ct,BorderLayout.CENTER);
		this.showActualMonth();
		this.validate();
	}
}
