package ch.il06.zeiterfassung.gui;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Date;

import javax.swing.JButton;

import ch.il06.zeiterfassung.db.Type;
import ch.il06.zeiterfassung.db.User;

public class CalendarField extends JButton implements ActionListener{

CalendarTable ct;
int day;
int month;
int year;
String activities = "Noch keine Aktivitten";
User user;
	
	public CalendarField(int day, int month, int year, CalendarTable ct, User user) {
		this.user = user;
		this.ct = ct;
		this.day = day;
		this.month = month;
		this.year = year;
		this.checkForTypes();
		this.setText(Integer.toString(day));
		this.setToolTipText(activities);
		this.addActionListener(this);
	}

	private void checkForTypes() {
		if (ct.isWorkDay(new Date(year-1900, month-1, day))) {
			this.updateLabel(Color.RED, "Arbeiten");
		}
	}

	public void updateLabel(Color color, String activity) {
		this.setBackground(color);
		this.setOpaque(true);
		this.setActivities(activity);
		this.setToolTipText(activities);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		new AddTime(day, month, year, ct.mf, user, this);
		System.out.println("Datum: " + day + "." + month + "." + year);
	}
	
	public void setActivities(String activities) {
		this.activities = activities;
	}
}
