package ch.il06.zeiterfassung.gui;

import java.awt.Color;
import java.awt.GridLayout;
import java.sql.Date;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

import ch.il06.zeiterfassung.db.Day;
import ch.il06.zeiterfassung.db.Type;
import ch.il06.zeiterfassung.db.User;
import ch.il06.zeiterfassung.db.Db;
import ch.il06.zeiterfassung.db.WorkDay;

public class CalendarTable extends JPanel{
	
ArrayList<JLabel> weekDays = new ArrayList<JLabel>();
String[] weekDayNames = {"Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag", "Sonntag"};
int month;
int year;
int firstDayOfWeek;
GregorianCalendar gc = new GregorianCalendar();
User user;
//Day[] activityDays;
WorkDay[] workDays;
MainFrame mf;


	/**
	 * 
	 * @param month = Monat als Zahl
	 * @param year = Jahr als Zahl
	 */
	public CalendarTable(int month, int year, User user, MainFrame mf) {
		this.mf = mf;
		this.user = user;
		this.month = month;
		this.year = year;
		this.workDays = Db.getInstance().getWorkDays(new Date(year-1900, month-1, 1), new Date(year-1900, month-1, getDaysOfMonth()), Db.getInstance().getCalendarByApprentice(user));
		this.createTable();
	}


	private void createLayout() {
		int rows = ((getFreeCount() + getDaysOfMonth() + 6) / 7);
		this.setLayout(new GridLayout((rows+1),7));
	}


	public void createTable() {
		this.createLayout();
		this.initializeWeekDays();
		this.addWeekDays();
		this.initializeDays();
	}


	private int getFreeCount() {
		return ((gc.get(GregorianCalendar.DAY_OF_WEEK)+5)%7);
	}



	private void initializeDays() {
		initializeVoidLabels();
		for (int i = 1; i <= getDaysOfMonth(); i++) {
			this.add(new CalendarField(i, gc.get(Calendar.MONTH), gc.get(Calendar.YEAR), this, user));
		}
		initializeLabelsInTheEnd();
	}


	private void initializeLabelsInTheEnd() {
		int voidLabels = (getFreeCount() + getDaysOfMonth()) % 7;
		voidLabels = 7 - voidLabels;
		if (voidLabels == 7) {
			return;
		}
		for (int i = 0; i < voidLabels; i++) {
			this.add(new JLabel(""));
		}
	}


	private void initializeVoidLabels() {
		for (int i = 0; i < getFreeCount(); i++) {
			this.add(new JLabel(""));
		}
	}


	private void addWeekDays() {
		for (JLabel jl : weekDays) {
			this.add(jl);
		}
	}


	private void initializeWeekDays() {
		for (int i = 0; i < 7; i++) {
			weekDays.add(new JLabel(weekDayNames[i]));
			weekDays.get(i).setHorizontalAlignment(SwingConstants.CENTER);
		}
	}


	public Boolean isWorkDay(java.util.Date date) {
		if (workDays == null) {
			return false;
		}
		for (Day d : workDays) {
			if (d.getDate().equals(date)) {
				return true;
			}
		}
		return false;
	}


	public int getDaysOfMonth() {
		gc.set(year, month, 1);
		return gc.getActualMaximum(GregorianCalendar.DATE);
	}
}
