package ch.il06.zeiterfassung.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import ch.il06.zeiterfassung.db.Db;
import ch.il06.zeiterfassung.db.DbInterface;
import ch.il06.zeiterfassung.db.Role;
import ch.il06.zeiterfassung.db.User;

public class Login extends ApplicationPanel implements ActionListener {

	JPanel centerPanel;
	GridBagConstraints gbc;
	JPanel mainPanel;
	JPanel northPanel;
	JButton login;
	private String pid;
	private String password;
	private JTextField inputPw;
	private JTextField inputPid;
	private String title="Login";
	JLabel errorMessage;

	public Login(MainFrame mf) {
		super(mf);
		createPanels();
		initGridConstraints();
		createSubmitButton();
		createInputFields();
		addComponents();
		this.add(mainPanel);
		this.validate();
		System.out.println("init");
	}

	private void createSubmitButton() {
		login = new JButton("Login");
		login.addActionListener(this);

	}

	private void createPanels() {
		createMainPanel();
		createCenterPanel();
		createNorthPanel();

	}

	private void createCenterPanel() {
		centerPanel = new JPanel();
		centerPanel.setLayout(new GridBagLayout());
		mainPanel.add(centerPanel, BorderLayout.CENTER);

	}

	private void createNorthPanel() {
		northPanel = new JPanel();
		northPanel.setLayout(new GridBagLayout());
		//northPanel.add(createTitleLabel("Login"));
		mainPanel.add(northPanel, BorderLayout.NORTH);
	}

	private Component createTitleLabel(String title) {
		JLabel label = new JLabel(title);
		Font f = label.getFont();
		Font f2 = f.deriveFont((float) f.getSize() * 3);
		label.setFont(f2);
		return label;
	}

	private void initGridConstraints() {
		gbc = new GridBagConstraints();
		gbc.weightx = 1.0;
		gbc.weighty = 1.0;

	}

	private void setConstraints(int x, int y, int w, int h, int pos, int top,
			int right, int bottom, int left) {
		setGridsConstraints(x, y);
		setDimensionConstraints(w, h);
		gbc.anchor = pos;
		setInsetsConstraints(top, right, bottom, left);
	}

	private void setDimensionConstraints(int w, int h) {
		gbc.gridheight = h;
		gbc.gridwidth = w;
	}

	private void setGridsConstraints(int x, int y) {
		gbc.gridx = x;
		gbc.gridy = y;
	}

	private void setInsetsConstraints(int top, int right, int bottom, int left) {
		gbc.insets.top = top;
		gbc.insets.right = right;
		gbc.insets.bottom = bottom;
		gbc.insets.left = left;
	}

	private void addComponents() {
		setConstraints(0, 0, 1, 1, GridBagConstraints.SOUTHEAST, 20, 20, 20, 20);
		centerPanel.add(new JLabel("PID:"), gbc);
		setConstraints(0, 1, 1, 1, GridBagConstraints.NORTHEAST, 20, 20, 0, 20);
		centerPanel.add(new JLabel("Passwort:"), gbc);
		setConstraints(1, 0, 1, 1, GridBagConstraints.SOUTHWEST, 20, 20, 20, 20);
		centerPanel.add(inputPid, gbc);
		setConstraints(1, 1, 1, 1, GridBagConstraints.NORTHWEST, 20, 20, 0, 20);
		centerPanel.add(inputPw, gbc);
		setConstraints(1, 2, 1, 1, GridBagConstraints.NORTHWEST, 20, 20, 0, 20);
		centerPanel.add(login, gbc);
		setConstraints(1, 3, 1, 1, GridBagConstraints.NORTHWEST, 20, 20, 0, 20);
		centerPanel.add(errorMessage = new JLabel(""), gbc);

	}

	private void createInputFields() {

		inputPid = new JTextField(20);
		inputPw = new JPasswordField(20);

	}

	private void createMainPanel() {
		mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout());
	}

	private void prepareLogin() {
		pid = inputPid.getText();
		password = inputPw.getText();
		DbInterface dbi = Db.getInstance();
		User user = dbi.login(pid, password);

		if (user != null) {  
			redirectUser(user);
		}

		else {
			errorMessage.setForeground(Color.RED);
			errorMessage.setText("PID oder Passwort nicht korrekt!");
		}

	}

	private void redirectUser(User user) {
		
		mf.setUser(user);
		
		//SWITCH sollte hier sein
			
		if(user.getRole().equals(Role.Apprentice)){
		mf.switchToPanel("Overview");
		}
		if(user.getRole().equals(Role.Instructor)){
		mf.switchToPanel("Sign");	
		}
		if(user.getRole().equals(Role.Master)){
		mf.switchToPanel("AdminOverview");	
		}
			
		
	}

	public void actionPerformed(ActionEvent e) {
		prepareLogin();
	}

	@Override
	public void refreshButtons() {
		// REMOVE ALL BUTTONS
		
	}

	@Override
	public String getTitle() {
		// TODO Auto-generated method stub
		return title;
	}

}
