package ch.il06.zeiterfassung.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.lang.reflect.Constructor;
import java.util.HashMap;

import javax.swing.JFrame;

import sun.reflect.ReflectionFactory.GetReflectionFactoryAction;

import ch.il06.zeiterfassung.db.User;
import ch.il06.zeiterfassung.gui.actions.OverviewAction;
import ch.il06.zeiterfassung.gui.actions.SignAction;

public class MainFrame extends JFrame {

	private HashMap<String, ApplicationPanel> panels;
	private User user;
	private MenuLayoutPanel mlp;

	public MainFrame() {

		initFrame();
		panels=new HashMap<String, ApplicationPanel>();
		switchToPanel("Login");

	}

	private void initFrame() {
		setTitle("Zeiterfassung CS");
		getContentPane().setLayout(new BorderLayout());
		setSize(640, 480);
		pack();
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		setLocation((d.width - getWidth()) / 2, (d.height - getHeight()) / 2);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setVisible(true);
		mlp = new MenuLayoutPanel(this);
		this.getContentPane().add(mlp);

	}

	/*private void initPanels() {
		panels = new HashMap<String, ApplicationPanel>();
		panels.put("Login", new Login(this));
		panels.put("Overview", new Overview(this));
		panels.put("Management", new Management(this));
		panels.put("GroupManagement", new GroupManagement(this));
		panels.put("AdminOverview", new AdminOverview(this));
		panels.put("Apprenticeship", new Apprenticeship(this));
		panels.put("HighDays", new HighDays(this));
		panels.put("Affliction", new Affliction(this));
		panels.put("Sign", new Sign(this));
		panels.put("Holiday", new Holiday(this)); // THOMAS IS THE WORST

	}*/



	public void switchToPanel(String panelName) {
		try {
			if (panels.get(panelName) == null) {
				Class<ApplicationPanel> classToInit = (Class<ApplicationPanel>) Class.forName("ch.il06.zeiterfassung.gui." + panelName);
				Constructor<?> constructor = classToInit
						.getConstructor(MainFrame.class);
				ApplicationPanel value = (ApplicationPanel) constructor
						.newInstance(new Object[] { this });
				panels.put(panelName, value);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		ApplicationPanel panel = panels.get(panelName);
		System.out.println(panelName);
		System.out.println(panel);
		panel.refreshButtons();
		mlp.addTitle(panel.getTitle());
		mlp.addCenterComponent(panel);
		this.validate();
	}

	public void setUser(User user) {
		this.user = user;

	}

	public MenuLayoutPanel getReferenceOfMLP() {

		return mlp;
	}

	public HashMap getReferenceOfPanels() {
		return panels;
	}

	public User getUser() {
		return user;
	}

}
