package ch.il06.zeiterfassung.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagLayout;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.plaf.basic.BasicSliderUI.ActionScroller;

import ch.il06.zeiterfassung.gui.actions.*;

public class MenuLayoutPanel extends JPanel {

	MainFrame mf;
	JPanel northPanel, westNorthPanel, centerPanel, westPanel, westSouthPanel;
	JButton overview,affliction,holidays,management,groupmanagement,sign,apprenticeship,highdays,adminOverview;
	public MenuLayoutPanel(MainFrame mf) {
		this.mf = mf;
		this.setLayout(new BorderLayout());
		createNorthPanel();
		createWestPanel();
		centerPanel=new JPanel();
		this.add(centerPanel,BorderLayout.CENTER);
		createWestPanel();
		createButtons();
		addTitle("Zeiterfassung");

	}
	
	public void showUserButtons(){
		
	
		westNorthPanel.removeAll();
		addMenuButton(overview, true);
		addMenuButton(affliction,true);
		addMenuButton(holidays, true);
		validate();
	}
	
	public void showAdminButtons(){
		westSouthPanel.removeAll();
		westNorthPanel.removeAll();
		addMenuButton(adminOverview,true);
		addMenuButton(apprenticeship,true);
		addMenuButton(highdays,true);
		addMenuButton(management, false);
		validate();
	}
	
	public void showInstructorButtons() {
		westSouthPanel.removeAll();
		westNorthPanel.removeAll();
		addMenuButton(sign,true);
		
	}

	private void createButtons() {
		overview=createButton("Overview");
		affliction=createButton("Affliction");
		holidays=createButton("Holiday");
		management=createButton("Management");
		groupmanagement=createButton("GroupManagement");
		sign=createButton("Sign");
		apprenticeship=createButton("Apprenticeship");
		highdays=createButton("Highdays");
		//adminOverview=createButton("AdminOverview");
		
		
	}


	private void createWestPanel() {
		westPanel = new JPanel();
		westPanel.setLayout(new BorderLayout());
		createWestNorthPanel();
		createWestSouthPanel();
		this.add(westPanel, BorderLayout.WEST);

	}

	private void createWestSouthPanel() {
		westSouthPanel = new JPanel();
		westSouthPanel
				.setLayout(new BoxLayout(westSouthPanel, BoxLayout.Y_AXIS));
		westSouthPanel.setBorder(BorderFactory
				.createEmptyBorder(10, 20, 10, 20));
		westPanel.add(westSouthPanel, BorderLayout.SOUTH);

	}

	private void createWestNorthPanel() {
		westNorthPanel = new JPanel();
		westNorthPanel
				.setLayout(new BoxLayout(westNorthPanel, BoxLayout.Y_AXIS));
		westNorthPanel.setBorder(BorderFactory
				.createEmptyBorder(10, 20, 10, 20));
		westPanel.add(westNorthPanel, BorderLayout.NORTH);
	}

	private void createNorthPanel() {
		northPanel = new JPanel();
		northPanel.setLayout(new GridBagLayout());
		this.add(northPanel, BorderLayout.NORTH);
	}

	public void addMenuButton(JButton button, boolean fromTop) {
		if (!fromTop) {
			westSouthPanel.add(button);
			westSouthPanel.add(Box.createVerticalStrut(10));
		}

		else {
			westNorthPanel.add(button);
			westNorthPanel.add(Box.createVerticalStrut(10));
		}
	}

	public void addCenterComponent(JComponent component) {
		centerPanel.removeAll();
		System.out.println("Componenets removed");
		centerPanel.add(component);
		mf.repaint();
	}

	public void addTitle(String title) {
		JLabel label = new JLabel(title);
		Font f = label.getFont();
		Font f2 = f.deriveFont((float) f.getSize() * 3);
		label.setFont(f2);
		northPanel.removeAll();
		northPanel.add(label);
	}

	public JButton createButton(String actionName) {
		JButton button = new JButton(AllActions.getAction(actionName, mf));
		return button;
	}

}
