package ch.il06.zeiterfassung.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Date;
import java.util.Collection;
import java.util.Arrays;

import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import ch.il06.zeiterfassung.db.Calendar;
import ch.il06.zeiterfassung.db.Day;
import ch.il06.zeiterfassung.db.Db;
import ch.il06.zeiterfassung.db.DbInterface;
import ch.il06.zeiterfassung.db.Role;
import ch.il06.zeiterfassung.db.User;
import ch.il06.zeiterfassung.db.UserCalendar;
import ch.il06.zeiterfassung.db.WorkDay;
import ch.il06.zeiterfassung.gui.tables.*;

public class Sign extends ApplicationPanel implements ActionListener {

	private String title = "Visieren";
	private UserCalendar cal;
	private DbInterface db = Db.getInstance();
	private int month;
	private int year;
	private SignTableModel sTM;
	private JComboBox monthDropDown;

	public Sign(MainFrame mf) {
		super(mf);
		System.out.println("User: " + mf.getUser());
		User lehrling = db.getUserByInstructor(mf.getUser())[0];
		cal = db.getCalendarByApprentice(lehrling);
		sTM = new SignTableModel(lehrling, cal, this);
		System.out.println("Calendar: " + cal);
		createNorthComponent();
		createCenterComponent(lehrling);

	}

	private void createNorthComponent() {
		JPanel northPanel = new JPanel();
		northPanel.setLayout(new FlowLayout());
		northPanel.add(new JLabel("Monat: "));
		northPanel.add(createDropDownMonth());
		// add(northPanel, monthDropDown);
		northPanel.setBackground(Color.PINK);
		add(northPanel, BorderLayout.NORTH);
	}

	private JComponent createDropDownMonth() {
		WorkDay[] workDays = db.getWorkDays(null, null, cal);
			Arrays.sort(workDays);

			monthDropDown = new JComboBox();
			monthDropDown.addActionListener(this);
			fillComboBox(workDays);
			return monthDropDown;
		
	}

	private void fillComboBox(Day[] days) {
		System.out.println("dbg.1");
		Date firstDate = (Date) days[0].getDate();
		this.month = firstDate.getMonth() + 1;
		this.year = firstDate.getYear() + 1900;
		Date lastDate = (Date) days[days.length - 1].getDate();
		int tempMonth = month, tempYear = year;
		int lastDateMonth=lastDate.getMonth() + 1;
		int lastDateYear=lastDate.getYear() + 1900;
		while (tempMonth != lastDateMonth
				|| tempYear != lastDateYear) {
			System.out.println("Loop");
			monthDropDown.addItem(new MonthYear(tempMonth, tempYear)); // die
																		// Angabe
																		// des
																		// Tages
																		// ist
																		// nicht
																		// relevant
			tempMonth++;
			if (tempMonth == 13){
				
				tempYear++;
			tempMonth = 1;
			}
		}
		monthDropDown.addItem(new MonthYear(tempMonth, tempYear));
	}

	class MonthYear {
		int month;
		int year;

		MonthYear(int month, int year) { // a=month b=year
			this.month = month;
			this.year = year;
		}

		@Override
		public String toString() {
			return month + " " + year;
		}
	}

	private void createCenterComponent(User lehrling) {
		JTable table = new JTable();
		
		table.setModel(sTM);
		JScrollPane scrollPane = new JScrollPane(table);
		add(scrollPane, BorderLayout.CENTER);
	}

	@Override
	public String getTitle() {
		// TODO Auto-generated method stub
		return title;
	}

	@Override
	public void refreshButtons() {
		if (mf.getUser().getRole().equals(Role.Instructor)) {
			mlp.showInstructorButtons();
		}
	}

	public int getMonth() {
		return month;
	}

	public void setMonth(int month) {
		this.month = month;
	}

	public int getYear() {
		return year;
	}

	public void setYear(int year) {
		this.year = year;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		MonthYear my=(MonthYear) monthDropDown.getSelectedItem();
		this.month=my.month;
		this.year=my.year;
		sTM.update();
	}

}
