package ch.il06.zeiterfassung.gui.actions;

import java.util.HashMap;

import ch.il06.zeiterfassung.gui.*;

public class AllActions {

private static HashMap<MainFrame, HashMap<String, ApplicationAction>> frames = new HashMap<MainFrame, HashMap<String, ApplicationAction>>();
	
	static {
		/*actions.put("overview", new UebersichtAction());
		actions.put("affliction", new KrankheitAction());
		actions.put("holiday", new FerienAction());
		actions.put("sign", new VisierenAction());
		actions.put("management", new VerwaltungAction());
		actions.put("highdays", new FeiertageAction());
		actions.put("apprenticeship", new AusbildungAction());
		actions.put("adminoverview", new AdminUebersichtAction());*/
	}

	
	public static ApplicationAction getAction(String actionName, MainFrame mf) {
		HashMap<String, ApplicationAction> actionTable = frames.get(mf);
		if (actionTable == null) {
			actionTable = new HashMap<String, ApplicationAction>();
			frames.put(mf, actionTable);
		}
		ApplicationAction action = actionTable.get(actionName);
		if (action == null) {
			try {
				action = (ApplicationAction) Class.forName("ch.il06.zeiterfassung.gui.actions." +actionName+ "Action").newInstance();
				action.setMainFrame(mf);
			} catch (Exception e) {
				System.err.println("Class " + actionName + " konnte nicht geladen werden. " + action);
				e.printStackTrace();
			}
			actionTable.put(actionName, action);
		}
		return action;
	}
	
	
}
