package ch.il06.zeiterfassung.gui.tables;



import java.util.GregorianCalendar;

import javax.swing.event.TableModelEvent;
import javax.swing.table.DefaultTableModel;

import ch.il06.zeiterfassung.db.Calendar;
import ch.il06.zeiterfassung.db.Db;
import ch.il06.zeiterfassung.db.DbInterface;
import ch.il06.zeiterfassung.db.User;
import ch.il06.zeiterfassung.gui.Sign;

public class SignTableModel extends DefaultTableModel{
	
	User lehrling, berufsbildner;
	Sign sign;
	Calendar cal;
	GregorianCalendar gregCal;
	
	String[] columnNames = {"Datum",
            				"Vormittag",
            				"Nachmittag",
            				"IST Zeit",
            				"SOLL Zeit",
            				"Differenz",
            				"Differenz Aktuell"};
	
	public SignTableModel(User lehrling, Calendar cal, Sign sign) {
		super();
		this.sign=sign;
		DbInterface db = Db.getInstance();
		this.cal = db.getCalendarByApprentice(lehrling);
		this.update();
	}
	
    public String getColumnName(int col) {
        return columnNames[col].toString();
    }

	public int getColumnCount(){
		return columnNames.length;
	}
	
	public int getRowCount(){
		
		if(sign == null){
			return 0;
		}
		
		gregCal = new GregorianCalendar();
		
		gregCal.set(sign.getYear(), sign.getMonth(), 1);
		
		return gregCal.getActualMaximum(GregorianCalendar.DATE);
	}
	
	public Object getValueAt(int row, int col) { //TODO : Benjamin D.
        return "dummy";//rowData[row][col];
    }
	
	public void update(){
		
		this.fireTableChanged(new TableModelEvent(this));
	}
}
